/*
(c) Janusz Ganczarski
http://www.januszg.hg.pl
JanuszG@enter.net.pl
*/

// wektor kierunku rda wiata

varying vec3 L;

void main ()
{
    // przypisanie wsprzdnych tekstur dla obu jednostek teksturujcych
    gl_TexCoord [0] = gl_MultiTexCoord0;
    gl_TexCoord [1] = gl_MultiTexCoord0;

    // obliczenie wektora kierunku rda wiata do biecego wierzchoka
    L = gl_LightSource[0].position - gl_Vertex;

    // pobranie wektora stycznego na podstawie informacji
    // zawartych w podstawowym kolorze wierzchoka
    vec3 T = gl_Color.xyz;

    // obliczenie drugiego wektora stycznego przy uyciu iloczynu wektorowego
    vec3 B = cross (T,gl_Normal);

    // obliczenie macierzy przeksztacenia
    mat3 TBN = mat3 (T,B,gl_Normal);

    // przeksztacenie wektora kierunku rda wiata
    L = TBN * L;

    // standardowe przeksztacenie wierzchokw
    gl_Position = ftransform ();
}